Hooks:PostHook(PlayerManager,"init","playermanager_init_slicer",function(self)
	self.slicer_multikill_active = false
	self.slicer_multikill_last_t = -42069 -- hee hee hee
end)

Hooks:PostHook(PlayerManager,"update","playermanager_update_slicer",function(self,t,dt)
	if self:has_category_upgrade("player","slicer_combo_turbo") and Utils:IsInHeist() and Utils:IsInGameState() then
		if self.slicer_multikill_last_t + tweak_data.upgrades.slicer_multikill_turbo_duration < t then
			self.slicer_multikill_active = false
			-- deactivates the buff because no good things are allowed to last forever
			-- in other words i have to include this or else the entire perk deck counts as a hack
		end
	end
end)

Hooks:PostHook(PlayerManager,"on_killshot","playermanager_killshot_slicer",function(self, killed_unit, variant, weapon_id)
	local WHATTIMEISIT = Application:time()
	if not self:player_unit() then
		return
	end
	if self:has_category_upgrade("player","slicer_combo_turbo") and variant == "melee" then
		if WHATTIMEISIT <= self.slicer_multikill_last_t + tweak_data.upgrades.slicer_combo_turbo_timer then
		-- YOU DID IT!
		self.slicer_multikill_active = true
		-- audio cue indicating the turbo is active
		self:player_unit():sound():play(tweak_data.blackmarket.projectiles.chico_injector.sounds.activate)
		-- alternate option: self:local_player():sound():say("goat_headbutt",false,true)
		else
		-- not fast enough nerd
		end
		self.slicer_multikill_last_t = WHATTIMEISIT
	else
	-- you don't have the deck maxed out because you are a moron
	end
end)

-- this *should* make the dodge buff effect actually work without completely fucking up the way the base game calculates dodge chances.
-- i might be wrong but here's hoping i'm not lol
local orig_calc_dodge = PlayerManager.skill_dodge_chance
function PlayerManager:skill_dodge_chance(...)
	local chance = 0
	local turboBonus = 0
	if self.slicer_multikill_active then
		turboBonus = tweak_data.upgrades.slicer_multikill_turbo_dodge_chance
	end
	
	chance = chance + orig_calc_dodge(self,...)
	
	chance = chance + turboBonus

	return chance
end